//--------------------------------------------------------------------
//----------------- shared.mq4-----EUROUSD--------------------------- 
//         MQL4.
//--------------------------------------------------------------------
#property copyright "Copyright  Book, 2008"
#property link      "http:moneymaker.co.za"
//--------------------------------------------------------------- 1 --
                      // Program Variables  
extern double StopLoss  =0;          // SL for open order
extern double TakeProfit=0;           // Take profit target
extern double Lots      =0;          // Fixed amounts of lots
extern double Prots     =0.03;         // Percent free margin
extern double OpeningBalance=500;

//-------------------------------------------------------------- 1a --

bool   Work=true;                      // EA will work
string Symb;                           // Security name
//--------------------------------------------------------------- 2 --
int start()
  {
   int
   Total,                              // Amount of orders in a window
   Tip=-1,                             // Type of selected order (B=0,S=1)
   Ticket;                             // Order number
   double
   Lot,                                // Amount of lots
   Lts,                                // Amount of lots in an open order
   Min_Lot,                            // Minimum amount of lots
   Step,                               // Step of lot size change
   Free,                               // Current free margin
   One_Lot,                            // Price of one lot
   Price,                              // Price of a selected order
   SL,                                 // SL of selected order
   TP;                                 // TP of selected order
   bool
   Ans  =false,                        // Server response after closing
   Cls_B=false,                        // Criteria for closing Buy
   Cls_S=false,                        // Criteria for closing Sell
   Opn_B=false,                        // Criteria for opening Buy
   Opn_S=false;                        // Criteria for opening Sell
//--------------------------------------------------------------- 3 --

//--------------------------------------------------------------- 4 --
   //------------- Orders accounting-------------------------------------
   Symb=Symbol();                               // Security name
   Total=0;                                     // Amount of orders
   for(int i=1; i<=OrdersTotal(); i++)          // Loop through orders
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) // If there is the next one
        {                                       // Analysing orders:
         if (OrderSymbol()!=Symb)continue;      // Another security
         if (OrderType()>1)                     // Pending order found
           {
            Alert("Pending Order detected, EA won't work");
            return;                             // Exit start()
           }
         Total++;                               // Counter of market orders
         if (Total>1)                           // No more than one order
           {
            Alert("Several market orders, EA won't work");
            return;                             // Exit start()
           }
         Ticket=OrderTicket();                  // 
         Tip   =OrderType();                    // Number of selescted order
         Price =OrderOpenPrice();               // Type of selected order
         SL    =OrderStopLoss();                // SL of selected order.
         TP    =OrderTakeProfit();              // TP of selected order.
         Lot   =OrderLots();                    // Amount of lots
        }
     }
//--------------------------------------------------------------- 5 --
   //----------Trading Criteria--------------------------------------
   double Filter_0=0;                // Filter_0
   double Ress=0;                // Filter_1
   double Supp=0;
   double EMA50_0=0;                     // stopping criteria
   double EMA25_0=0;
   double StopL=0;
   double DeMarkTD=0;
   double DeMark_0=0;
   double DeMark_1=0;
   string UpTD;
   double UpTDValueDown=0;
   double UpTDValueUp=0;
  //-------------------------------------------------------------- 5a --

   Ress=iCustom(NULL,0,"Support and Resistance (Barry)",0,0);
   Supp=iCustom(NULL,0,"Support and Resistance (Barry)",1,0);
   DeMark_0=iCustom(NULL,0,"Demark_trend_alert_and_mail",3000,2,1,0,0,true,true,false,false,false,0,true,true,Green,Red,3,false,false,0,0);

     for (i=0;i<ObjectsTotal();i++)
       {
        UpTD=ObjectName(i);
        
        if(StringFind(UpTD,"HL_1")==0)
        if(StringFind(UpTD,"LL_1")==0)
           {
           UpTDValueDown=ObjectGet("HL_1",1);
           UpTDValueUp=ObjectGet("LL_1",1);
           }
       }   
//-------------------------------------------------------------- 5b --
   if (Close[0]>UpTDValueDown+10*Point)// && Close[0]>Ress+5*Point)
       
     {
      Opn_B=true;                               // Criteria for opening Buy
      Cls_S=true;                               // Criteria for closing Sell
     }
   if (Close[0]<UpTDValueUp-10*Point)// && Close[0]<Supp-5*Point)
     {
      Opn_S=true;                               // Criteria for opening Sell
      Cls_B=true;                               // Criteria for closing Buy
     }
//--------------------------------------------------------------- 6 --
   //----------Closing Orders
   while(true)                                  // Loop of closing orders.
     {
      if (Tip==0 && Close[0]<UpTDValueUp)              // Order Buy is open
        {                                       //and there is criteria to close
         Alert("Attempt to close Buy ",Ticket,". Waiting for response..");
         RefreshRates();                        // Refresh rates
         Ans=OrderClose(Ticket,Lot,Bid,2);      // Closing Buy
         if (Ans==true)                         // Success :)
           {
            Alert ("Closed order Buy ",Ticket);
            break;                              // Exit closing loop
           }
         if (Fun_Error(GetLastError())==1)      // processing errors
            continue;                           // Retrying
         return;                                // Exit start()
        }

      if (Tip==1 && Close[0]>UpTDValueDown)             //  Order Sell is open
        {                                       // and the is criterio to close
         Alert("Attempt to close Sell ",Ticket,". Waiting for response...");
         RefreshRates();                        // Refresh rates
         Ans=OrderClose(Ticket,Lot,Ask,2);      // Closing Sell
         if (Ans==true)                         // Success :)
           {
            Alert ("Closed order Sell ",Ticket);
            break;                              // Exit closing loop
           }
         if (Fun_Error(GetLastError())==1)      // Procesing errors
            continue;                           // Retrying
         return;                                // Exit start()
        }
      break;                                    // Exit while
     }
//--------------------------------------------------------------- 7 --
   // Order value
   RefreshRates();                              // Refresh rates
   Min_Lot=MarketInfo(Symb,MODE_MINLOT);        // Minimum number of lots 
   Free   =AccountFreeMargin();                 // Free margin
   One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);// Price of 1 lot
   Step   =MarketInfo(Symb,MODE_LOTSTEP);       // Step of 1 lot

   if (Lots > 0)                                // If lots are set
      Lts =Lots;                                //work with them
   else                                         // % of free margin
      Lts=NormalizeDouble((Free/OpeningBalance)*0.5,2);// For opening

   if(Lts < 0.1) {Lts=0.1;}               // Not less than minimum
//   if (Lts*One_Lot > Free)                      // Lot larger than free margin.
//     {
//      Alert(" Not enough money for , Lts,lots");
//      return;                                   // Exit start()
//     }
//--------------------------------------------------------------- 8 --
   // Opening orders
   while(true)                                  // Order closing loop.
     {
      if (Total==0 && Opn_B==true)              // No new orders
        {                                       // criteria for opening Buy
         RefreshRates();                        // Refresh rate
         if(StopLoss==0) {SL=0;}
         else{SL=Bid-1*StopLoss;}     // Calculating SL of open.
         if(TakeProfit==0) {TP=0;}
         else{TP=Bid + TakeProfit*Point;}    // Calculating TP of open.
         Alert("Atempt to open Buy. Waiting for response..");
         Ticket=OrderSend(Symb,OP_BUY,Lts,Ask,2,SL,TP);//Opening Buy
         if (Ticket > 0)                        // Success :)
           {
            Alert ("Open order Buy ",Ticket);
            return;                             // Exit start()
           }
         if (Fun_Error(GetLastError())==1)      // Processing errors
            continue;                           // Retrying
         return;                                // Exit start()
        }
      if (Total==0 && Opn_S==true)              // No new orders open
        {                                       // criteria for opening Sell
         RefreshRates();                        // Refresh rate
         if(StopLoss==0) {SL=0;}
         else{SL=Ask+1*StopLoss;}     // Calculating SL of open
         if(TakeProfit==0) {TP=0;}
         else {TP=Ask - TakeProfit*Point;}   // Calculating TP of open..
         Alert("Attempt to open Sell. Waiting for response..");
         Ticket=OrderSend(Symb,OP_SELL,Lts,Bid,2,SL,TP);//Opening order Sel
         if (Ticket > 0)                        // Success :)
           {
            Alert ("Opened order Sell ",Ticket);
            return;                             // Exit start()
           }
         if (Fun_Error(GetLastError())==1)      // Processing errors
            continue;                           // Retrying
         return;                                // Exit start()
        }
      break;                                    // Exit while
     }
//--------------------------------------------------------------- 9 --
   return;                                      // Exit start()
  }
//-------------------------------------------------------------- 10 --
int Fun_Error(int Error)                        // Function for processing errors
  {
   switch(Error)
     {                                          // Not crucial errors            
      case  4: Alert("Trade server is busy. Trying once again..");
         Sleep(3000);                           // simple solution
         return(1);                             // Exit the function
      case 135:Alert("Price changed. Trying once again");
         RefreshRates();                        // Refresh rate
         return(1);                             // Exit the function
      case 136:Alert("No price. waiting for a new tick..");
         while(RefreshRates()==false)           // Till a new tick
            Sleep(1);                           // Pause in the loop
         return(1);                             // Exit the function
      case 137:Alert("Broker is busy, still trying..");
         Sleep(3000);                           // Simple solution
         return(1);                             // Exit the function
      case 146:Alert("Trading subsysten is busy");
         Sleep(500);                            // Simple solution
         return(1);                             // Exit the function
         // Critical errors
      case  2: Alert("Common errors");
         return(0);                             // Exit the function
      case  5: Alert("Old terminal version");
         Work=false;                            // Terminate operation
         return(0);                             // Exit the function
      case 64: Alert("Account blocked");
         Work=false;                            // Terminate operation
         return(0);                             // Exit the function
      case 133:Alert("Trading forbiden");
         return(0);                             // Exit the function
      case 134:Alert("Not enough money.");
         return(0);                             // Exit the function
      default: Alert("Error occured , Error");   // Other variants  
         return(0);                             // Exit the function
     }
  }
  //} 
//-------------------------------------------------------------- 11 --

